#include "hmbdc/Copyright.hpp"
#pragma once 
#include "hmbdc/pattern/PoolConsumer.hpp"
#include <stdint.h>
#include <memory>

namespace hmbdc { namespace pattern { 

template <typename Buffer>
struct PoolT {
    using ptr = std::shared_ptr<PoolT<Buffer>>;
    void addConsumer(PoolConsumer&, uint64_t poolThreadAffinityIn = 0xfffffffffffffffful);
    uint32_t consumerSize() const;
    void start(uint16_t threadCount, uint64_t cpuAffinityMask = 0
    	, bool thatIsAll = true);
    void startAll(uint64_t cpuAffinityMask = 0);
    void startThruRecycling(uint16_t threadCount, uint64_t cpuAffinityMask = 0);
    void runOnce(uint16_t threadSerialNumber);
    void stop();
    void join();
    static
    std::shared_ptr<PoolT> create(Buffer& lfb, uint32_t maxConsumerSize) {
        return std::shared_ptr<PoolT>(
                new PoolT(lfb, maxConsumerSize)
        );
    }
    ~PoolT();

private:
    PoolT(Buffer&, uint32_t);
    void* impl_;
};

}}