#pragma once 

#include <boost/type_traits.hpp>
#include <tuple>

namespace hmbdc { namespace pattern {
template <typename T>
struct function_traits: function_traits<decltype(&T::operator())>
{};

template <typename ClassType, typename ReturnType, typename... Args>
struct function_traits<ReturnType(ClassType::*)(Args...) const> {
    enum { arity = sizeof...(Args) };
    typedef ReturnType result_type;

    template <size_t i>
    struct arg {
        using type = typename std::tuple_element<i, std::tuple<Args...>>::type;
    };
};

template <typename ClassType, typename ReturnType, typename... Args>
struct function_traits<ReturnType(ClassType::*)(Args...)> {
    enum { arity = sizeof...(Args) };

    typedef ReturnType result_type;

    template <size_t i>
    struct arg {
        using type = typename std::tuple_element<i, std::tuple<Args...>>::type;
    };
};

template <typename Base, typename Derived>
struct is_first_base_of{
    enum {
        value = std::is_base_of<Base, Derived>::value 
               && (Base const*)((Derived const*)0xffff) == ((Base const*)0xffff)
    };
};
}}
